# Az - Logic Apps Post Exploitation

{{#include ../../../banners/hacktricks-training.md}}

## Logic Apps Database Post Exploitation
Za više informacija o logic apps, proverite:

{{#ref}}
../az-services/az-logic-apps.md
{{#endref}}

### `Microsoft.Logic/workflows/read`, `Microsoft.Logic/workflows/write` && `Microsoft.ManagedIdentity/userAssignedIdentities/assign/action`
Sa ovim dozvolama, možete modifikovati Logic App radne tokove i upravljati njihovim identitetima. Konkretno, možete dodeliti ili ukloniti sistemski dodeljene i korisnički dodeljene upravljane identitete radnim tokovima, što omogućava Logic App-u da se autentifikuje i pristupi drugim Azure resursima bez eksplicitnih kredencijala.
```bash
az logic workflow identity remove/assign \
--name <workflow_name> \
--resource-group <resource_group_name> \
--system-assigned true \
--user-assigned "/subscriptions/<subscription_id>/resourceGroups/<resource_group>/providers/Microsoft.ManagedIdentity/userAssignedIdentities/<identity_name>"
```
Dodatno, sa samo `Microsoft.Logic/workflows/write` možete promeniti neke konfiguracije kao što su dozvoljene dolazne IP adrese ili dani zadržavanja istorije izvršavanja:
```bash
az rest --method PUT \
--uri "https://management.azure.com/subscriptions/<subscription_id>/resourceGroups/<resource_group>/providers/Microsoft.Logic/workflows/<workflow_name>?api-version=2019-05-01" \
--headers "Content-Type=application/json" \
--body '{
"location": "<location>",
"properties": {
"state": "Enabled",
"definition": {
"$schema": "https://schema.management.azure.com/providers/Microsoft.Logic/schemas/2016-06-01/workflowdefinition.json#",
"contentVersion": "1.0.0.0",
"parameters": {},
"triggers": {
"<trigger_name>": {
"type": "Request",
"kind": "Http"
}
},
"actions": {},
"outputs": {}
},
"runtimeConfiguration": {
"lifetime": {
"unit": "day",
"count": <count>
}
},
"accessControl": {
"triggers": {
"allowedCallerIpAddresses": []
},
"actions": {
"allowedCallerIpAddresses": []
}
}
}
}'
```
### `Microsoft.Web/sites/read`, `Microsoft.Web/sites/write`
Sa ovim dozvolama, možete kreirati ili ažurirati Logic Apps hostovane na App Service Plan-u. To uključuje modifikovanje podešavanja kao što su omogućavanje ili onemogućavanje primene HTTPS-a.
```bash
az logicapp update \
--resource-group <resource_group_name> \
--name <logic_app_name> \
--set httpsOnly=false
```
### `Microsoft.Web/sites/stop/action`, `Microsoft.Web/sites/start/action` || `Microsoft.Web/sites/restart/action`
Sa ovom dozvolom, možete pokrenuti/zaustaviti/restartovati web aplikaciju, uključujući Logic Apps hostovane na App Service Plan-u. Ova akcija osigurava da se prethodno zaustavljena aplikacija ponovo pokrene i nastavi sa svojom funkcionalnošću. Ovo može ometati radne tokove, pokrenuti nepredviđene operacije ili izazvati prekid rada pokretanjem, zaustavljanjem ili restartovanjem Logic Apps iznenada.
```bash
az webapp start/stop/restart \
--name <logic_app_name> \
--resource-group <resource_group_name>
```
### `Microsoft.Web/sites/config/list/action`, `Microsoft.Web/sites/read` && `Microsoft.Web/sites/config/write`

Sa ovom dozvolom, možete konfigurisati ili modifikovati podešavanja za web aplikacije, uključujući Logic Apps hostovane na App Service Plan-u. Ovo omogućava promene u podešavanjima aplikacije, konekcionim stringovima, konfiguracijama autentifikacije i još mnogo toga.
```bash
az logicapp config appsettings set \
--name <logic_app_name> \
--resource-group <resource_group_name> \
--settings "<key>=<value>"
```
### `Microsoft.Logic/integrationAccounts/write`
Sa ovom dozvolom, možete kreirati, ažurirati ili brisati Azure Logic Apps integracione naloge. Ovo uključuje upravljanje konfiguracijama na nivou integracionog naloga kao što su mape, sheme, partneri, sporazumi i još mnogo toga.
```bash
az logic integration-account create \
--resource-group <resource_group_name> \
--name <integration_account_name> \
--location <location> \
--sku <Standard|Free> \
--state Enabled
```
### `Microsoft.Resources/subscriptions/resourcegroups/read` && `Microsoft.Logic/integrationAccounts/batchConfigurations/write`

Sa ovom dozvolom, možete kreirati ili modifikovati batch konfiguracije unutar Azure Logic Apps integracionog naloga. Batch konfiguracije definišu kako Logic Apps obrađuju i grupišu dolazne poruke za batch obradu.
```bash
az logic integration-account batch-configuration create \
--resource-group <resource_group_name> \
--integration-account-name <integration_account_name> \
--name <batch_configuration_name> \
--release-criteria '{
"messageCount": 100,
"batchSize": 1048576,
}'
```
### `Microsoft.Resources/subscriptions/resourcegroups/read` && `Microsoft.Logic/integrationAccounts/maps/write`
Sa ovom dozvolom, možete kreirati ili modifikovati mape unutar Azure Logic Apps integracionog naloga. Mape se koriste za transformaciju podataka iz jednog formata u drugi, omogućavajući besprekornu integraciju između različitih sistema i aplikacija.
```bash
az logic integration-account map create \
--resource-group <resource_group_name> \
--integration-account-name <integration_account_name> \
--name <map_name> \
--map-type <Xslt|Xslt20|Xslt30> \
--content-type application/xml \
--map-content map-content.xslt
```
### `Microsoft.Resources/subscriptions/resourcegroups/read` && `Microsoft.Logic/integrationAccounts/partners/write`
Sa ovom dozvolom, možete kreirati ili modifikovati partnere u Azure Logic Apps integracionom nalogu. Partneri predstavljaju entitete ili sisteme koji učestvuju u poslovnim tokovima između preduzeća (B2B).
```bash
az logic integration-account partner create \
--resource-group <resource_group_name> \
--integration-account-name <integration_account_name> \
--name <partner_name> \
--partner-type <partner-type> \
--content '{
"b2b": {
"businessIdentities": [
{
"qualifier": "ZZ",
"value": "TradingPartner1"
}
]
}
}'
```
### `Microsoft.Resources/subscriptions/resourcegroups/read` && `Microsoft.Logic/integrationAccounts/sessions/write`
Sa ovom dozvolom, možete kreirati ili modifikovati sesije unutar Azure Logic Apps integracionog naloga. Sesije se koriste u B2B radnim tokovima za grupisanje poruka i praćenje povezanih transakcija tokom definisanog perioda.
```bash
az logic integration-account session create \
--resource-group <resource_group_name> \
--integration-account-name <integration_account_name> \
--name <session_name> \
--content '{
"properties": {
"sessionId": "session123",
"data": {
"key1": "value1",
"key2": "value2"
}
}
}'
```
### `Microsoft.Logic/workflows/regenerateAccessKey/action`

Korisnici sa ovom dozvolom mogu da regenerišu pristupne ključeve za Logic App, a ako se zloupotrebe, to može dovesti do prekida usluga.
```bash
az rest --method POST \
--uri "https://management.azure.com/subscriptions/<subscription-id>/resourceGroups/<resource-group>/providers/Microsoft.Logic/workflows/<workflow-name>/regenerateAccessKey?api-version=<api-version>" \
--body '{"keyType": "<key-type>"}' \
--headers "Content-Type=application/json"

```
### "*/delete"
Sa ovim dozvolama možete obrisati resurse povezane sa Azure Logic Apps



{{#include ../../../banners/hacktricks-training.md}}
